package de.uks.pmws112.hexentanz;

import org.eclipse.swt.graphics.Image;
import org.eclipse.wb.swt.SWTResourceManager;

import de.uks.pmws112.hexentanz.gui.HexentanzMainScreen;
import de.uks.pmws112.hexentanz.model.HexentanzGame;
import de.uks.pmws112.hexentanz.model.Player;
import de.uks.pmws112.hexentanz.model.Witch;

public class Util
{
  
   public static Image getUnknownWitchImage()
   {
      String path = "/img/witchUnkown.png";
      return SWTResourceManager.getImage(HexentanzMainScreen.class, path);
   }

   public static Image getImage(Witch witch)
   {
      StringBuilder sb = new StringBuilder();

      sb.append("/img/witch");
      sb.append(witch.getColor());
      sb.append(".png");
      
      return SWTResourceManager.getImage(HexentanzMainScreen.class, sb.toString());
   }

   public static Player findPlayer(String name, HexentanzGame game)
   {
      for(Player p : game.getPlayers())
      {
         if(name.equals(p.getName()))
         {
            return p;
         }
      }

      return null;
   }
}
