package de.uks.pmws112.hexentanz.gui;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.FocusAdapter;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.wb.swt.SWTResourceManager;

import swing2swt.layout.BorderLayout;

public class HexentanzStartScreen
{
   private class RestoreContentFocusAdapter extends FocusAdapter
   {
      
      private final String toRestore;

      public RestoreContentFocusAdapter(String toRestore)
      {
         this.toRestore = toRestore;
      }
      
      @Override
      public void focusGained(FocusEvent e)
      {
         Text text = getText(e);
         if(toRestore.equals(text.getText()))
         {
            text.setText("");
         }
      }
      
      @Override
      public void focusLost(FocusEvent e)
      {
         Text text = getText(e);
         if(text.getText() == null || text.getText().trim().length() == 0)
         {
            text.setText(toRestore);
         }
      }

      private Text getText(FocusEvent e)
      {
         Text t = (Text)e.widget;
         return t;
      }
   }

	protected Shell shlStartGame;
	private Text player1Text;
	private Text player2Text;
	private Text player3Text;
	private Composite buttonPane;
	private Button startButton;
	private Button exitButton;
	private Label lblHexentanz;
	private Label label;
	private Label label_1;
	private Label label_2;
	private Label label_3;
	private Text player4Text;

	/**
	 * Create contents of the window.
	 * @wbp.parser.entryPoint
	 */
	public void createContents()
	{
		shlStartGame = new Shell();
		shlStartGame.setSize(451, 379);
		shlStartGame.setText("Hexentanz Start");
		shlStartGame.setLayout(new BorderLayout(0, 0));
		
		Composite playerPane = new Composite(shlStartGame, SWT.NONE);
		playerPane.setLayoutData(BorderLayout.CENTER);
		GridLayout gl_playerPane = new GridLayout(1, false);
		playerPane.setLayout(gl_playerPane);
		
		Composite playerNamesPane = new Composite(playerPane, SWT.NONE);
		playerNamesPane.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
		GridLayout gl_playerNamesPane = new GridLayout(2, false);
		gl_playerNamesPane.verticalSpacing = 10;
		playerNamesPane.setLayout(gl_playerNamesPane);
		
		label = new Label(playerNamesPane, SWT.NONE);
		label.setImage(SWTResourceManager.getImage(HexentanzStartScreen.class, "/img/witchGreenSmall.png"));
		label.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		
		player1Text = new Text(playerNamesPane, SWT.BORDER | SWT.CENTER);
		player1Text.setForeground(SWTResourceManager.getColor(SWT.COLOR_WIDGET_BORDER));
		player1Text.setFont(SWTResourceManager.getFont("Segoe UI", 18, SWT.NORMAL));
		player1Text.setText("Player 1");
		player1Text.addFocusListener(new RestoreContentFocusAdapter("Player 1"));
		player1Text.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		
		label_1 = new Label(playerNamesPane, SWT.NONE);
		label_1.setImage(SWTResourceManager.getImage(HexentanzStartScreen.class, "/img/witchPurpleSmall.png"));
		label_1.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		
		player2Text = new Text(playerNamesPane, SWT.BORDER | SWT.CENTER);
		player2Text.setForeground(SWTResourceManager.getColor(SWT.COLOR_WIDGET_BORDER));
		player2Text.setFont(SWTResourceManager.getFont("Segoe UI", 18, SWT.NORMAL));
		player2Text.setText("Player 2");
		player2Text.addFocusListener(new RestoreContentFocusAdapter("Player 2"));
		player2Text.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		
		label_2 = new Label(playerNamesPane, SWT.NONE);
		label_2.setImage(SWTResourceManager.getImage(HexentanzStartScreen.class, "/img/witchRedSmall.png"));
		label_2.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		
		player3Text = new Text(playerNamesPane, SWT.BORDER | SWT.CENTER);
		player3Text.setForeground(SWTResourceManager.getColor(SWT.COLOR_WIDGET_BORDER));
		player3Text.setFont(SWTResourceManager.getFont("Segoe UI", 18, SWT.NORMAL));
		player3Text.setText("Player 3");
		player3Text.addFocusListener(new RestoreContentFocusAdapter("Player 3"));
		player3Text.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		
		label_3 = new Label(playerNamesPane, SWT.NONE);
		label_3.setImage(SWTResourceManager.getImage(HexentanzStartScreen.class, "/img/witchYellowSmall.png"));
		label_3.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		
		player4Text = new Text(playerNamesPane, SWT.BORDER | SWT.CENTER);
		player4Text.setForeground(SWTResourceManager.getColor(SWT.COLOR_WIDGET_BORDER));
		player4Text.setFont(SWTResourceManager.getFont("Segoe UI", 18, SWT.NORMAL));
		player4Text.setText("Player 4");
		player4Text.addFocusListener(new RestoreContentFocusAdapter("Player 4"));
		player4Text.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		
		buttonPane = new Composite(shlStartGame, SWT.NONE);
		buttonPane.setLayoutData(BorderLayout.SOUTH);
		RowLayout rl_buttonPane = new RowLayout(SWT.HORIZONTAL);
		rl_buttonPane.marginRight = 10;
		rl_buttonPane.marginLeft = 10;
		rl_buttonPane.justify = true;
		rl_buttonPane.center = true;
		buttonPane.setLayout(rl_buttonPane);
		
		exitButton = new Button(buttonPane, SWT.NONE);
		exitButton.setText("Exit Game");
		
		startButton = new Button(buttonPane, SWT.NONE);
		startButton.setText("Start Game");
		
		lblHexentanz = new Label(shlStartGame, SWT.NONE);
		lblHexentanz.setFont(SWTResourceManager.getFont("Papyrus", 17, SWT.BOLD));
		lblHexentanz.setAlignment(SWT.CENTER);
		lblHexentanz.setLayoutData(BorderLayout.NORTH);
		lblHexentanz.setText("Hexentanz");

	}
	
	public void open()
	{
		shlStartGame.open();
		shlStartGame.layout();
	}

	public Button getStartButton() {
		return startButton;
	}
	public Button getExitButton() {
		return exitButton;
	}
	public Text getPlayer1Text() {
		return player1Text;
	}
	public Text getPlayer2Text() {
		return player2Text;
	}
	public Text getPlayer3Text() {
		return player3Text;
	}
	public Shell getStartGameShell() {
		return shlStartGame;
	}
   public Text getPlayer4Text() {
      return player4Text;
   }
}
